/*
 * I2C.h
 *
 *  Created on: 2012-7-26
 *      Author: shulen
 */

#ifndef I2C_H_
#define I2C_H_
////////////////////////////////
////////////////////////////////
#ifdef	IN_DISPLAY
	#define	IN_DISPLAY_EXTERN
#else
	#define	IN_DISPLAY_EXTERN extern
#endif
#ifdef IN_DISPLAY
#define  seg_h 0x01
#define  seg_c 0x02
#define  seg_b 0x04
#define  seg_a 0x08
#define  seg_d 0x10
#define  seg_e 0x20
#define  seg_g 0x40
#define  seg_f 0x80
//-----------------------------------------------------------------------------
// Define characters
//-----------------------------------------------------------------------------
// 7-segment arragment :
//       a
//     -----
//    |     |
//   f|     |b
//    |  g  |
//     -----
//    |     |
//   e|     |c
//    |  d  |
//     -----  . h
 unsigned char Lcdseg[16]={
         seg_a+seg_b+seg_c+seg_d+seg_e+seg_f, // char "0"
         seg_b+seg_c,                         // char "1"
         seg_a+seg_b+seg_d+seg_e+seg_g,       // char "2"
         seg_a+seg_b+seg_c+seg_d+seg_g,       // char "3"
         seg_b+seg_c+seg_f+seg_g,             // char "4"
         seg_a+seg_c+seg_d+seg_f+seg_g,       // char "5"
         seg_a+seg_c+seg_d+seg_e+seg_f+seg_g, // char "6"
         seg_a+seg_b+seg_c,                   // char "7"
         seg_a+seg_b+seg_c+seg_d+seg_e+seg_f+seg_g,  // char "8"
         seg_a+seg_b+seg_c+seg_d+seg_f+seg_g, // char "9"
         seg_a+seg_b+seg_c+seg_e+seg_f+seg_g, // char "A"
         seg_c+seg_d+seg_e+seg_f+seg_g,       // char "b"
         seg_a+seg_d+seg_e+seg_f,             // char "C"
         seg_b+seg_c+seg_d+seg_e+seg_g,       // char "d"
         seg_a+seg_d+seg_e+seg_f+seg_g,       // char "E"
         seg_a+seg_e+seg_f+seg_g};
/* unsigned char Lcd1seg[16]={
		01+02+0x08+0x20+0x40+0x80,
		0x20+0x40,
		01+02+04+0x40+0x80,
		01+04+0x20+0x40+0x80,
		04+0x08+0x20+0x40,
		01+04+0x08+0x20+0x80,
		01+02+04+0x08+0x20+0x80,
		0x20+0x40+0x80,
		0x01+0x02+0x04+0x08+0x20+0x40+0x80,
		0x01+0x04+0x08+0x20+0x40+0x80};*/
/////////////////////////////////
#define SDA_1	SDA_high()
#define SDA_0	SDA_low()
#define SCL_1	SCL_high()
#define SCL_0	SCL_low()

//////////////////////////////////////
void I2C_stop(void);
void I2C_start(void);
void I2C_init(void);
void I2C_waitack(void);
void I2C_ack(void);
void I2C_senddata(unsigned char a);
//////////////////////////////////
void SCL_high(void)
{
	inw(0x40810)=0x0400;
	inw(0x40814)=0x04040000; //enable input mode  20141030
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
}
void SCL_low(void)
{
	inw(0x40810)=0x0404;
	inw(0x40814)=0x04000400; //disable input and output '0' 20141030
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
}
void SDA_high(void)
{
	inw(0x40810)=0x0800;
	inw(0x40814)=0x08080000; //enable input 20141030
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
}
void SDA_low(void)
{
	inw(0x40810)=0x0808;
	inw(0x40814)=0x08000800; //disable input ,and output '0';20141030
	asm("nop");
	asm("nop");
	asm("nop");
	asm("nop");
}
#endif /* I2C_H_ */
IN_DISPLAY_EXTERN unsigned char lcd[17];
IN_DISPLAY_EXTERN void INI_DISPLAY(void);
IN_DISPLAY_EXTERN void lcddisplayshu(unsigned char index,unsigned int dispdata);
IN_DISPLAY_EXTERN void lcddisplayall(void);
IN_DISPLAY_EXTERN void lcddisplayclear(void);
IN_DISPLAY_EXTERN void lcddisplaydian(unsigned char k);
IN_DISPLAY_EXTERN void lcddisplayheart(unsigned char b);
IN_DISPLAY_EXTERN void LCDDisplayErrorMessage(unsigned char a);
IN_DISPLAY_EXTERN void lcddisplaymemory(unsigned char memorydata);
IN_DISPLAY_EXTERN void lcddisplaytime(unsigned char mesg);
IN_DISPLAY_EXTERN void lcddisplaysign(void);

#endif

