/*
 * display.c

 *
 *  Created on: 2012-8-1
 *      Author: shulen
 */
#define IN_DISPLAY
#include "signal.h"
/////////////////////////////////////////////
void INI_DISPLAY(void)//initial the display
{
	unsigned char i;
     I2C_init();
   	 Delay(0x20000);
   	 I2C_stop();
     I2C_start();
     I2C_senddata(0x7c);//Slave_addr equ  07Ch
     I2C_waitack();
     I2C_senddata(0xea);//ICSET equ  0EAh
   	 Delay(0x20000);
     I2C_senddata(0xbc);//DISCTL equ  0Bch
     I2C_waitack();
     I2C_senddata(0);//ADSET equ  000h
     I2C_ack();
     for(i=0;i<17;i++)
     {
    	 I2C_senddata(0x00);//0X00
         I2C_ack();
     }
     I2C_senddata(0x00);//0X00
     I2C_waitack();
     I2C_stop();


     //initial LCD buffer
Lcdseg[0]=seg_a+seg_b+seg_c+seg_d+seg_e+seg_f;// char "0"
Lcdseg[1]=seg_b+seg_c;                         // char "1"
Lcdseg[2]=seg_a+seg_b+seg_d+seg_e+seg_g;       // char "2"
Lcdseg[3]=seg_a+seg_b+seg_c+seg_d+seg_g;       // char "3"
Lcdseg[4]=seg_b+seg_c+seg_f+seg_g;             // char "4"
Lcdseg[5]=seg_a+seg_c+seg_d+seg_f+seg_g;       // char "5"
Lcdseg[6]=seg_a+seg_c+seg_d+seg_e+seg_f+seg_g; // char "6"
Lcdseg[7]=seg_a+seg_b+seg_c;                   // char "7"
Lcdseg[8]=seg_a+seg_b+seg_c+seg_d+seg_e+seg_f+seg_g;  // char "8"
Lcdseg[9]=seg_a+seg_b+seg_c+seg_d+seg_f+seg_g; // char "9"
Lcdseg[10]=seg_a+seg_b+seg_c+seg_e+seg_f+seg_g; // char "A"
Lcdseg[11]=seg_c+seg_d+seg_e+seg_f+seg_g;       // char "b"
Lcdseg[12]=seg_a+seg_d+seg_e+seg_f;             // char "C"
Lcdseg[13]=seg_b+seg_c+seg_d+seg_e+seg_g;       // char "d"
Lcdseg[14]=seg_a+seg_d+seg_e+seg_f+seg_g;       // char "E"
Lcdseg[15]=seg_a+seg_e+seg_f+seg_g;
}
///////////////////////////////////////
void lcddisplayclear(void)//ram write the lcd
{
	unsigned char i;
     I2C_stop();
     I2C_start();
     I2C_senddata(0x7c);//Slave_addr equ  07Ch
     I2C_waitack();
     I2C_senddata(0xbc);//
     I2C_waitack();
     I2C_senddata(0xf0);//
     I2C_waitack();
     I2C_senddata(0xfc);//
     I2C_waitack();
     I2C_senddata(0xc8);//
     I2C_waitack();
     //LCD RAM Clear All
     I2C_senddata(0x00);//address
     I2C_waitack();
     for(i=0;i<18;i++)
     {
    	 I2C_senddata(0x00);//0X00
         I2C_waitack();
     }
     I2C_stop();
     for(i=0;i<=14;i++)
     {
    	 lcd[i]=0;
     }
}
////////////////////////////////////////
void lcddisplayshu(unsigned char index,unsigned int dispdata)//ram write the lcd
{
	unsigned char i,temp,addr,dispbuffer[3]={0};
	dispbuffer[0]=Lcdseg[dispdata/100];
	dispbuffer[1]=Lcdseg[dispdata/10%10];
	dispbuffer[2]=Lcdseg[dispdata%10];
	switch(index)
	{
	case 0:			//ܰ
		addr=0x14;
		break;
	case 1:			//ܧC
		addr=0x0e;
        break;
	case 2:			//ܤ߲v
		addr=0x06;
		break;
	default:
		break;
	}
     I2C_stop();
     I2C_start();
     I2C_senddata(0x7c);//Slave_addr equ  07Ch
     I2C_waitack();
     I2C_senddata(0xbc);//
     I2C_waitack();
     I2C_senddata(0xf0);//
     I2C_waitack();
     I2C_senddata(0xfc);//
     I2C_waitack();
     I2C_senddata(0xc8);//
     I2C_waitack();
     //I2C_senddata(0xe8);//
     //I2C_waitack();

     /*I2C_stop();  //20141125
     I2C_start(); //20141125
     I2C_senddata(0x7c);//Slave_addr equ  07Ch
     I2C_waitack();//20141125*/

     //LCD RAM
     I2C_senddata(addr);//address
     I2C_waitack();
     for(i=0;i<3;i++)
     {
         I2C_senddata(dispbuffer[i]);
         I2C_waitack();
     }

     I2C_stop();
}
////////////////////////////////////////////
void lcddisplayall(void)
{
	unsigned char i;
    I2C_stop();
    I2C_start();
    I2C_senddata(0x7c);//Slave_addr equ  07Ch
    I2C_waitack();
    I2C_senddata(0xbc);//
    I2C_waitack();
    I2C_senddata(0xf0);//
    I2C_waitack();
    I2C_senddata(0xfc);//
    I2C_waitack();
    I2C_senddata(0xc8);//
    I2C_waitack();
    I2C_senddata(0x00);//address
    I2C_waitack();
    for(i=0;i<18;i++)
    {
   	 I2C_senddata(0xff);//0X00
        I2C_waitack();
    }
    I2C_stop();
}
/////////////////////////////////////////
void lcddisplaytime(unsigned char mesg)
{
	unsigned char temp,addr,dispbuffer[7]={0};
	signed char i;
	switch(mesg)
	{
	case 0: 	//ܮɶ
		dispbuffer[0]=Lcdseg[hour/10];
		dispbuffer[1]=Lcdseg[hour%10];
		if((lcd[15]&0x01)==0x01)
		{
			dispbuffer[1]=dispbuffer[1]|0x01;
		}
		dispbuffer[2]=Lcdseg[minute/10];
		dispbuffer[3]=Lcdseg[minute%10];
		break;
	case 1:		//ܤ
		dispbuffer[0]=Lcdseg[month/10];
		dispbuffer[1]=Lcdseg[month%10];
		dispbuffer[2]=Lcdseg[data/10];
		dispbuffer[3]=Lcdseg[data%10];
		break;
	case 2:		//ܦ~
		dispbuffer[0]=Lcdseg[year/1000];
		dispbuffer[1]=Lcdseg[year/100%10];
		dispbuffer[2]=Lcdseg[year/10%10];
		dispbuffer[3]=Lcdseg[year%10];
		break;
	default:
		break;
	}
	if((mode==3)&&((lcd[15]&0x01)==0))
	{
		if((settime_step==0x01)||(settime_step==0x04))
		{
			dispbuffer[0]=0;
			dispbuffer[1]=0;
		}
		else if((settime_step==0x2)||(settime_step==0x05))
		{
			dispbuffer[2]=0;
			dispbuffer[3]=0;
		}
		if(settime_step==0x3)
		{
			dispbuffer[2]=0;
			dispbuffer[3]=0;
			dispbuffer[0]=0;
			dispbuffer[1]=0;
		}

	}
    I2C_stop();
    I2C_start();
    I2C_senddata(0x7c);//Slave_addr equ  07Ch
    I2C_waitack();
    I2C_senddata(0xbc);//
    I2C_waitack();
    I2C_senddata(0xf0);//
    I2C_waitack();
    I2C_senddata(0xfc);//
    I2C_waitack();
    I2C_senddata(0xc8);//
    I2C_waitack();
    //LCD RAM Clear All
    I2C_senddata(28);//address
    I2C_waitack();
    for(i=0;i<4;i++)
    {
   	 I2C_senddata(dispbuffer[i]);//0X00
        I2C_waitack();
    }
    I2C_stop();
}
/////////////////////////////////////////
void lcddisplayheart(unsigned char b)
{
	if(b==1)
	{
		lcd[13]=lcd[3]|0x0f;
	}
	else lcd[13]=lcd[13]&0xf0;
    I2C_stop();
	I2C_start();
	I2C_senddata(0x7c);//Slave_addr equ  07Ch
	I2C_waitack();
	I2C_senddata(0xbc);//
	I2C_waitack();
	I2C_senddata(0xf0);//
	I2C_waitack();
	I2C_senddata(0xfc);//
	I2C_waitack();
	I2C_senddata(0xc8);//
	I2C_waitack();
	I2C_senddata(0x26);//address
	I2C_waitack();
	I2C_senddata(lcd[13]);//0X00
	I2C_waitack();
	I2C_stop();
}
/////////////////////////////////////////
void lcddisplaysign(void)
{
    I2C_stop();
	I2C_start();
	I2C_senddata(0x7c);//Slave_addr equ  07Ch
	I2C_waitack();
	I2C_senddata(0xbc);//
	I2C_waitack();
	I2C_senddata(0xf0);//
	I2C_waitack();
	I2C_senddata(0xfc);//
	I2C_waitack();
	I2C_senddata(0xc8);//
	I2C_waitack();
	I2C_senddata(0x26);//address
	I2C_waitack();
	I2C_senddata(lcd[13]);//0X00
	I2C_waitack();
	I2C_stop();
}
/////////////////////////////////////////
void lcddisplaydian(unsigned char k)
{
	if(k==1)
	{
	lcd[15]=lcd[15]|0x01;
	}
	else lcd[15]=lcd[15]&0xfe;
    I2C_stop();
	I2C_start();
	I2C_senddata(0x7c);//Slave_addr equ  07Ch
	I2C_waitack();
	I2C_senddata(0xbc);//
	I2C_waitack();
	I2C_senddata(0xf0);//
	I2C_waitack();
	I2C_senddata(0xfc);//
	I2C_waitack();
	I2C_senddata(0xc8);//
	I2C_waitack();
	I2C_senddata(0x30);//address
	I2C_waitack();
	I2C_senddata(lcd[15]);//0X00
	I2C_waitack();
	I2C_stop();
}
//////////////////////////////////////////
void LCDDisplayErrorMessage(unsigned char a)
{
	if(a==0)
	{
	    I2C_stop();
	    I2C_start();
	    I2C_senddata(0x7c);//Slave_addr equ  07Ch
	    I2C_waitack();
	    I2C_senddata(0xbc);//
	    I2C_waitack();
	    I2C_senddata(0xf0);//
	    I2C_waitack();
	    I2C_senddata(0xfc);//
	    I2C_waitack();
	    I2C_senddata(0xc8);//
	    I2C_waitack();
	     //LCD RAM
	    I2C_senddata(4);//address
	    I2C_waitack();
	    I2C_senddata(Lcdseg[14]);
	    I2C_waitack();
	    I2C_senddata(0x46);
	    I2C_waitack();
	    I2C_senddata(0x46);
	    I2C_waitack();
	    I2C_stop();
	}
}
//////////////////////////////////////////
void lcddisplaymemory(unsigned char memorydata)
{
	unsigned char i,dispbuffer[4]={0};
	dispbuffer[0]=Lcdseg[memorydata/10];
	dispbuffer[1]=Lcdseg[memorydata%10];

	dispbuffer[2]=00;
    I2C_stop();
	I2C_start();
	I2C_senddata(0x7c);//Slave_addr equ  07Ch
	I2C_waitack();
	I2C_senddata(0xbc);//
	I2C_waitack();
	I2C_senddata(0xf0);//
	I2C_waitack();
	I2C_senddata(0xfc);//
	I2C_waitack();
	I2C_senddata(0xc8);//
	I2C_waitack();
	    //LCD RAM Clear All
	I2C_senddata(0x0);//address
	I2C_waitack();
	for(i=0;i<=2;i++)
	    {
	   	 I2C_senddata(dispbuffer[i]);//0X00
	        I2C_waitack();
	    }
	    I2C_stop();
}
//////////////////////////////////////////
void I2C_stop(void)
{
	 SCL_0;
	 SDA_0;
	 SCL_1;
	 SDA_1;
	 SCL_0;
}
void I2C_start(void)
{
	SCL_0;
	SDA_1;
	SCL_1;
	SDA_0;
	SCL_0;
}
void I2C_init(void)
{
	inw(0x40810)=0x0c0c0000;
	inw(0x40814)=0x0c0c0000;//pull hi enable
}
void I2C_ack(void)
{
	SCL_0;
	SCL_1;
	SCL_0;
}
void I2C_waitack(void)
{
	unsigned int a;
	unsigned char b;
	SCL_0;
	SCL_1;
	a=inw(0x40808)&0x40;
	if(a!=0)
	{
		b=1;
	}
	else b=0;
	SCL_0;
	//return b;
}
////////////////////////////////////////////
void I2C_senddata(unsigned char a)
{
	unsigned char i;
	for(i=0;i<8;i++)
	{
		SCL_0;
		if(a>=0x80)
		{
			SDA_1;
		}
		else SDA_0;
		a=a<<1;
		SCL_1;
	}
	SCL_0;
	SDA_1;
}


